<?php

namespace FiloBlu\DisableShop\Model\ResourceModel;

use Magento\Catalog\Model\Config as CatalogConfig;
use Magento\Catalog\Model\ResourceModel\Product\Collection as ProductCollection;
use Magento\Framework\ObjectManagerInterface;

class ProductCollectionFactory extends \Magento\Catalog\Model\ResourceModel\Product\CollectionFactory
{
    /**
     * @var CatalogConfig
     */
    protected $catalogConfig;

    public function __construct(ObjectManagerInterface $objectManager, CatalogConfig $catalogConfig, $instanceName = ProductCollection::class)
    {
        parent::__construct($objectManager, $instanceName);
        $this->catalogConfig = $catalogConfig;
    }

    public function create(array $data = array())
    {
        $collection = parent::create($data);
        $collection->addAttributeToSelect($this->catalogConfig->getProductAttributes());
        return $collection;
    }
}
