<?php

namespace FiloBlu\DisableShop\Observer;

use Magento\Framework\Event\Observer as EventObserver;
use Magento\Framework\Event\ObserverInterface;

class LayoutGenerateBlocksAfter implements ObserverInterface {

    protected $_helper;

    public function __construct(
    \FiloBlu\DisableShop\Helper\Data $helper
    ) {
        $this->_helper = $helper;
    }

    /**
     * Apply is salable to product
     *
     * @param EventObserver $observer
     * @return $this
     */
    public function execute(EventObserver $observer) {

        $this->_helper->log("### Layout Generate Blocks After ###");

        if ($this->_helper->canDisableShop()) {
            /** @var \Magento\Framework\View\Layout $layout */
            $layout = $observer->getLayout();
            $_notAllowedBlocks = explode("\n", $this->_helper->getConfig("general/not_allowed_blocks"));

            $this->_helper->log("- Not Allowed Blocks: " . $this->_helper->getConfig("general/not_allowed_blocks"));
           
            foreach ($_notAllowedBlocks as $notAllowedBlock) {
                $block = $layout->getBlock(trim($notAllowedBlock));

                if ($block) {
                    $layout->unsetElement(trim($notAllowedBlock));
                    $this->_helper->log("- Remove Block -> " . $notAllowedBlock);
                }
            }
        }

        return $this;
    }

}
