<?php

namespace FiloBlu\DisableShop\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;

class UpgradeSchema implements UpgradeSchemaInterface
{

    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $setup->startSetup();

        //handle all possible upgrade versions

        if (!$context->getVersion()) {
            //no previous version found, installation, InstallSchema was just executed
            //be careful, since everything below is true for installation !
        }

        if (version_compare($context->getVersion(), '1.0.1') < 0) {

           try {
                $setup->getConnection()->query("UPDATE `eav_attribute` SET `frontend_input` = 'boolean' WHERE `attribute_code` IN ('disable_shop','hide_price') AND `frontend_input` <> 'boolean'");
            } catch (\Exception $e) {
                throw new \Exception("Error changed disable shop input type to boolean for FE", 1);
            }

        }

        $setup->endSetup();
    }

}
